/**
 *    returns index of the character at position given by its x and y coordinates related to the top-left screen corner.
 *    The returned index calculated in a string composed of all text nodes contents
 */
function indexOfCharacterAtPosition(x, y) {
    /*console.log("calculate index at: (" + x + "," + y + ")");*/
    var range;
    if (document.caretPositionFromPoint) {
        var caretPosition = document.caretPositionFromPoint(x, y);
        var node = caretPosition.offsetNode;
        var offset = caretPosition.offset;
        range = document.createRange();
        range.setStart(node, offset);
        range.setEnd(node, offset);
    } else {
        range = document.caretRangeFromPoint(x, y);
    }

    if (range == null) {
        /*alert('range is null x: ' + x + ' y: ' + y + 'content height: ' + document.documentElement.scrollWidth);*/
        var element = document.elementFromPoint(x, y);
        if (element) {
            /*alert(element.outerHTML);*/
        }
        return "null";
    } else {
        if (range.startContainer.nodeType == 3) {
            /*alert('range not null: ' + range.startContainer.nodeValue); */
        } else {
            var imgs = range.startContainer.getElementsByTagName('img');
            if(imgs.length > 0) {
                return imgs[0].getAttribute('id')
            }
        }
    }

    var index = range2Index(range);
    /*alert('index: ' + index);*/
    return index;
}