function positionToRange(start, end) {
    var iterator =
        document.createNodeIterator(document.body, NodeFilter.SHOW_TEXT,
            null, false);
    var node = iterator.nextNode();
    if (node) {
        var range = document.createRange();
        var currentCharacter = 0;
        var charactersRead;
        var startNode = false;
        var endNode = false;
        while (node) {
            var value = node.nodeValue;
            if (value != null) {
                charactersRead = currentCharacter + value.length;
                if (!startNode && charactersRead > start) {
                    range.setStart(node, start - currentCharacter);
                    startNode = true;
                }
                if (!endNode && charactersRead >= end) {
                    range.setEnd(node, end - currentCharacter);
                    endNode = true;
                }
                if (startNode && endNode) {
                    break;
                }
                currentCharacter = charactersRead;
            }
            node = iterator.nextNode();
        }
        return range;
    }
}